# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need Test::More ≥ 0.96, so use a bundled one if we don't have it
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.96) ? 1 : 0);' 2>/dev/null || echo 0)

# --with reply_plugin
#	Default: --without
# Missing deps (perl(Reply::Plugin))
# Marked as unstable (cf. lib/Reply/Plugin/TypeTiny.pm)
%bcond_with reply_plugin

Name:		perl-Type-Tiny
Version:	1.000006
Release:	1.%{__distinit}%{__distvers}
Summary:	Tiny, yet Moo(se)-compatible type constraint
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Type-Tiny/
Source0:	http://www.cpan.org/authors/id/T/TO/TOBYINK/Type-Tiny-%{version}.tar.gz
Source1:	T-M-0.96.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl >= 0:5.006001
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.0
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
# Module Runtime
BuildRequires:	perl(B)
BuildRequires:	perl(Exporter::Tiny) >= 0.026
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(Text::Balanced)
BuildRequires:	perl(utf8)
BuildRequires:	perl(warnings)
# Optional Module Runtime
BuildRequires:	perl(B::Deparse)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Devel::LexAlias) >= 0.05
BuildRequires:	perl(Devel::StackTrace)
%{?with_reply_plugin:
BuildRequires:	perl(Reply::Plugin)
BuildRequires:	perl(Term::ANSIColor)}
BuildRequires:	perl(Sub::Name)
# Test Suite
BuildRequires:	perl(base)
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
BuildRequires:	perl(Encode)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(lib)
BuildRequires:	perl(Math::BigFloat)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(Test::Builder::Module)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(Benchmark)
BuildRequires:	perl(Devel::Cover)
BuildRequires:	perl(Devel::Hide)
BuildRequires:	perl(JSON::PP)
BuildRequires:	perl(Method::Generate::Accessor)
BuildRequires:	perl(Moo) >= 1.003
BuildRequires:	perl(Moo::Role)
BuildRequires:	perl(Moose) >= 2.06
BuildRequires:	perl(MooseX::Types)
BuildRequires:	perl(MooseX::Types::Moose)
BuildRequires:	perl(Mouse) >= 1.0000
BuildRequires:	perl(Role::Tiny)
BuildRequires:	perl(Role::Tiny::With)
BuildRequires:	perl(Sub::Quote)
BuildRequires:	perl(Test::LeakTrace)
BuildRequires:	perl(Test::Moose)
BuildRequires:	perl(Test::Tester) >= 0.109
# Test::Warnings requires Test::More ≥ 0.94
%if 0%{?fedora} > 8 || 0%{?rhel} > 5
BuildRequires:	perl(Test::Warnings)
%endif
BuildRequires:	perl(Test::Without::Module)
BuildRequires:	perl(threads)
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(Tie::Scalar)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(B::Deparse)
Requires:	perl(Carp)
Requires:	perl(Data::Dumper)
Requires:	perl(Devel::LexAlias) >= 0.05
Requires:	perl(Devel::StackTrace)
Requires:	perl(Sub::Name)

# Optional Modules not yet available
#TODO: BuildRequires:	perl(Class::InsideOut) >= 1.13
#TODO: BuildRequires:	perl(Function::Parameters) >= 1.0103
#TODO: BuildRequires:	perl(Kavorka)
#TODO: BuildRequires:	perl(match::simple)
#TODO: BuildRequires:	perl(Moops)
#TODO: BuildRequires:	perl(MooseX::Getopt) >= 0.63
#TODO: BuildRequires:	perl(MooseX::Types::Common) >= 0.001004
#TODO: BuildRequires:	perl(MouseX::Types)
#TODO: BuildRequires:	perl(MouseX::Types::Moose)
#TODO: BuildRequires:	perl(Object::Accessor) >= 0.30
#TODO: BuildRequires:	perl(Return::Type) >= 0.004
#TODO: BuildRequires:	perl(Sub::Exporter::Lexical) >= 0.092291
#TODO: BuildRequires:	perl(Switcheroo)
#TODO: BuildRequires:	perl(Type::Tie)
#TODO: BuildRequires:	perl(Type::Tiny::XS)
#TODO: BuildRequires:	perl(Types::Path::Tiny)
#TODO: BuildRequires:	perl(Types::XSD::Lite)
#TODO: BuildRequires:	perl(Validation::Class::Simple)

%description
Type::Tiny is a tiny class for creating Moose-like type constraint objects
that are compatible with Moo, Moose and Mouse.

%package -n perl-Test-TypeTiny
Summary:	Test::TypeTiny module
Group:		Development/Libraries

%description -n perl-Test-TypeTiny
Test::TypeTiny module.

%prep
%setup -q -n Type-Tiny-%{version}

# We need Test::More ≥ 0.96, so use a bundled one if we don't have it
%if %{old_test_more}
tar xfz %{SOURCE1}
find inc/Test -type f >> MANIFEST
%endif

%build
# Use our local Test::More if necessary
[ -d inc/Test/ ] && export PERL5LIB=$(pwd)/inc

perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
# Use our local Test::More if necessary
[ -d inc/Test/ ] && export PERL5LIB=$(pwd)/inc

make test EXTENDED_TESTING=1

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license COPYRIGHT LICENSE
%else
%doc COPYRIGHT LICENSE
%endif
%doc Changes CREDITS NEWS README
%{perl_vendorlib}/Devel/
%{perl_vendorlib}/Error/
%{perl_vendorlib}/Eval/
%{!?with_reply_plugin:
%exclude }%{perl_vendorlib}/Reply/
%{perl_vendorlib}/Type/
%{perl_vendorlib}/Types/
%{_mandir}/man3/Devel::TypeTiny::Perl56Compat.3*
%{_mandir}/man3/Devel::TypeTiny::Perl58Compat.3*
%{_mandir}/man3/Error::TypeTiny.3*
%{_mandir}/man3/Error::TypeTiny::Assertion.3*
%{_mandir}/man3/Error::TypeTiny::Compilation.3*
%{_mandir}/man3/Error::TypeTiny::WrongNumberOfParameters.3*
%{_mandir}/man3/Eval::TypeTiny.3*
%{!?with_reply_plugin:
%exclude }%{_mandir}/man3/Reply::Plugin::TypeTiny.3*
%{_mandir}/man3/Type::Coercion.3*
%{_mandir}/man3/Type::Coercion::FromMoose.3*
%{_mandir}/man3/Type::Coercion::Union.3*
%{_mandir}/man3/Type::Library.3*
%{_mandir}/man3/Type::Params.3*
%{_mandir}/man3/Type::Parser.3*
%{_mandir}/man3/Type::Registry.3*
%{_mandir}/man3/Type::Tiny.3*
%{_mandir}/man3/Type::Tiny::Class.3*
%{_mandir}/man3/Type::Tiny::Duck.3*
%{_mandir}/man3/Type::Tiny::Enum.3*
%{_mandir}/man3/Type::Tiny::Intersection.3*
%{_mandir}/man3/Type::Tiny::Manual.3*
%{_mandir}/man3/Type::Tiny::Manual::Coercions.3*
%{_mandir}/man3/Type::Tiny::Manual::Libraries.3*
%{_mandir}/man3/Type::Tiny::Manual::Optimization.3*
%{_mandir}/man3/Type::Tiny::Manual::Params.3*
%{_mandir}/man3/Type::Tiny::Manual::Policies.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoose.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMouse.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithOther.3*
%{_mandir}/man3/Type::Tiny::Role.3*
%{_mandir}/man3/Type::Tiny::Union.3*
%{_mandir}/man3/Type::Tiny::_HalfOp.3*
%{_mandir}/man3/Type::Utils.3*
%{_mandir}/man3/Types::Common::Numeric.3*
%{_mandir}/man3/Types::Common::String.3*
%{_mandir}/man3/Types::Standard.3*
%{_mandir}/man3/Types::Standard::ArrayRef.3*
%{_mandir}/man3/Types::Standard::Dict.3*
%{_mandir}/man3/Types::Standard::HashRef.3*
%{_mandir}/man3/Types::Standard::Map.3*
%{_mandir}/man3/Types::Standard::ScalarRef.3*
%{_mandir}/man3/Types::Standard::Tuple.3*
%{_mandir}/man3/Types::TypeTiny.3*

%files -n perl-Test-TypeTiny
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::TypeTiny.3*

%changelog
* Tue Jan 31 2017 Paul Howarth <paul@city-fan.org> - 1.000006-1
- Update to 1.000006
  - Fix escaping within q{...} in a test case (CPAN RT#114386)

* Mon Jan  9 2017 Paul Howarth <paul@city-fan.org> - 1.000005-8
- Test::Warnings now available back to F-9

* Fri Oct 14 2016 Paul Howarth <paul@city-fan.org> - 1.000005-7
- BR: perl-generators where available
- Simplify find command using -delete
- Re-enable use of Devel::Cover for all builds

* Wed Jul  1 2015 Paul Howarth <paul@city-fan.org> - 1.000005-2
- Avoid use of Devel::Cover with Perl 5.22 onwards for now
  (https://github.com/pjcj/Devel--Cover/issues/126)

* Sun Oct 26 2014 Paul Howarth <paul@city-fan.org> - 1.000005-1
- Update to 1.000005
  - Fix short-circuiting optimizations for parameterized HashRef, ArrayRef,
    ScalarRef and Map type constraints (CPAN RT#99312)
  - Fix annoying warning message in test suite with recent versions of
    Exporter::Tiny

* Thu Oct  2 2014 Paul Howarth <paul@city-fan.org> - 1.000004-3
- Import from Fedora

* Thu Sep 04 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000004-2
- Perl 5.20 rebuild

* Thu Sep 04 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000004-1
- Upstream update

* Mon Sep 01 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000003-2
- Perl 5.20 rebuild

* Sun Aug 31 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000003-1
- Upstream update

* Fri Aug 22 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000002-1
- Upstream update
- Update deps

* Mon Aug 18 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000000-1
- Upstream update

* Thu Jul 24 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.046-1
- Upstream update

* Mon Jun 23 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.044-1
- Upstream update
- Spec file cosmetics
- BR: perl(Test::Moose), perl(MooseX::Getopt)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.042-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Apr 08 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.042-1
- Upstream update
- Split out perl(Test::TypeTiny) to avoid deps on perl(Test::*)

* Fri Mar 21 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.040-1
- Initial Fedora package
